Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text
Imports System.Globalization

Namespace MSDNMagazine
	Public Class MSDNMagazineServiceType
		Implements IMSDNMagazineService
		Private Shared _firstYear As Integer = 2001
		Public Function GetAllIssues() As IssuesCollection Implements IMSDNMagazineService.GetAllIssues
			Dim allIssues As New IssuesCollection()
			Dim years As Integer = DateTime.Now.AddYears(1).Year - _firstYear
			For i As Integer = 0 To years - 1
				allIssues.Add((_firstYear + i).ToString())
			Next i
			Return allIssues

		End Function



		Public Function GetIssuesByYear(ByVal year As String) As IssuesData Implements IMSDNMagazineService.GetIssuesByYear
			Dim issue As IssuesData = New IssuesData With {.Year = year, .Issues = New MonthInfo()}
			Dim c As Calendar = New GregorianCalendar()
			Dim ci As CultureInfo = CultureInfo.CurrentCulture

			Dim mnths As Integer = c.GetMonthsInYear(Int32.Parse(year))
			For j As Integer = 0 To mnths - 1
				issue.Issues.Add(ci.DateTimeFormat.MonthNames(j))
			Next j
			Return issue

		End Function



		#Region "IIssues Members"


		Public Function GetIssue(ByVal year As String, ByVal issue As String) As Articles Implements IMSDNMagazineService.GetIssue
			Dim ret = _
				From a In _articles _
				Where a.Year = year AndAlso a.Issue = issue _
				Select a
			Dim temp As New Articles()
			temp.AddRange(ret)
			Return temp
		End Function
		Private Shared _articles As Articles = InitArticles()

		Private Shared Function InitArticles() As Articles
			Dim ret As New Articles()
			ret.Add(New Article With {.Title = "SAAS: Connect Enterprise Apps with Hosted BizTalk Services ", .Content = "In this article we introduce you to BizTalk Services, new technology that offers the Enterprise Service Bus features of BizTalk Server as a hosted service.", .Author = "Jon Flanders and Aaron Skonnard", .Id = "1", .Year = "2008", .Issue = "June"})


			ret.Add(New Article With {.Title = "Concurrency: Tools And Techniques to Identify Concurrency Issues", .Content = "Efficient parallel applications arent born by merely running an old app on a parallel processor machine. Tuning needs to be done if youre to gain maximum benefit.", .Author = "Rahul V. Patil and Boby George", .Id = "2", .Year = "2008", .Issue = "June"})

			ret.Add(New Article With {.Title = "Robotics: Simulating the World with Microsoft Robotics Studio", .Content = "Microsoft Robotics Studio is not just for playing with robots. It also allows you to build service-based applications for a wide range of hardware devices.", .Author = "Sara Morgan", .Id = "3", .Year = "2008", .Issue = "June"})

			ret.Add(New Article With {.Title = "Form Filler: Build Workflows to Capture Data and Create Documents", .Content = "Learn how to create a workflow that uses InfoPath forms and other office documents for passing data to targeted activities and for use in Office documents.", .Author = "Rick Spiewak", .Id = "4", .Year = "2008", .Issue = "June"})
			Return ret
		End Function

		Public Function GetArticle(ByVal year As String, ByVal issue As String, ByVal article As String) As Article Implements IMSDNMagazineService.GetArticle
			Dim a As Article = Nothing
			a = ( _
					From arts In _articles _
					Where arts.Id = article AndAlso arts.Issue = issue AndAlso arts.Year = year _
					Select arts).Single()
			Return a
		End Function

		#End Region

		#Region "IIssues Members"


		Public Function AddArticle(ByVal year As String, ByVal issue As String, ByVal article As Article) As Article Implements IMSDNMagazineService.AddArticle
			Dim count = ( _
					From a In _articles _
					Where a.Year = year AndAlso a.Issue = issue _
					Select a).Count()
			article.Id = (count + 1).ToString()
			_articles.Add(article)
			Return article

		End Function

		#End Region
	End Class
End Namespace
